package net.mcreator.riflespistolsandmachineguns.procedures;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.server.ServerWorld;
import net.minecraft.world.World;
import net.minecraft.world.IWorld;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.ResourceLocation;
import net.minecraft.particles.ParticleTypes;
import net.minecraft.block.Block;

import net.mcreator.riflespistolsandmachineguns.RiflesPistolsAndMachineGunsMod;

import java.util.Map;

public class BulletHitEffectProcedure {
	public static void executeProcedure(Map<String, Object> dependencies) {
		if (dependencies.get("x") == null) {
			if (!dependencies.containsKey("x"))
				RiflesPistolsAndMachineGunsMod.LOGGER.warn("Failed to load dependency x for procedure BulletHitEffect!");
			return;
		}
		if (dependencies.get("y") == null) {
			if (!dependencies.containsKey("y"))
				RiflesPistolsAndMachineGunsMod.LOGGER.warn("Failed to load dependency y for procedure BulletHitEffect!");
			return;
		}
		if (dependencies.get("z") == null) {
			if (!dependencies.containsKey("z"))
				RiflesPistolsAndMachineGunsMod.LOGGER.warn("Failed to load dependency z for procedure BulletHitEffect!");
			return;
		}
		if (dependencies.get("world") == null) {
			if (!dependencies.containsKey("world"))
				RiflesPistolsAndMachineGunsMod.LOGGER.warn("Failed to load dependency world for procedure BulletHitEffect!");
			return;
		}
		double x = dependencies.get("x") instanceof Integer ? (int) dependencies.get("x") : (double) dependencies.get("x");
		double y = dependencies.get("y") instanceof Integer ? (int) dependencies.get("y") : (double) dependencies.get("y");
		double z = dependencies.get("z") instanceof Integer ? (int) dependencies.get("z") : (double) dependencies.get("z");
		IWorld world = (IWorld) dependencies.get("world");
		if (world instanceof ServerWorld) {
			((ServerWorld) world).spawnParticle(ParticleTypes.SMOKE, x, y, z, (int) 5, 0.25, 0.25, 0.25, 0.05);
		}
		if (world instanceof ServerWorld) {
			((ServerWorld) world).spawnParticle(ParticleTypes.LARGE_SMOKE, x, y, z, (int) 1, 0.375, 0.375, 0.375, 0.075);
		}
		world.playEvent(2001, new BlockPos((int) x, (int) (y + 1), (int) z),
				Block.getStateId((world.getBlockState(new BlockPos((int) x, (int) y, (int) z)))));
		if (world instanceof World && !world.isRemote()) {
			((World) world).playSound(null, new BlockPos((int) x, (int) y, (int) z),
					(net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS
							.getValue(new ResourceLocation("rifles_pistols_and_machine_guns:bhit")),
					SoundCategory.NEUTRAL, (float) 0.05, (float) (1 + ((-0.5) * Math.random())));
		} else {
			((World) world).playSound(x, y, z,
					(net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS
							.getValue(new ResourceLocation("rifles_pistols_and_machine_guns:bhit")),
					SoundCategory.NEUTRAL, (float) 0.05, (float) (1 + ((-0.5) * Math.random())), false);
		}
	}
}
