
package net.mcreator.riflespistolsandmachineguns.item;

import net.minecraftforge.registries.ObjectHolder;

import net.minecraft.world.World;
import net.minecraft.util.text.StringTextComponent;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.item.Rarity;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.block.BlockState;

import net.mcreator.riflespistolsandmachineguns.RiflesPistolsAndMachineGunsModElements;

import java.util.List;

@RiflesPistolsAndMachineGunsModElements.ModElement.Tag
public class LowQBulletItem extends RiflesPistolsAndMachineGunsModElements.ModElement {
	@ObjectHolder("rifles_pistols_and_machine_guns:low_q_bullet")
	public static final Item block = null;
	public LowQBulletItem(RiflesPistolsAndMachineGunsModElements instance) {
		super(instance, 19);
	}

	@Override
	public void initElements() {
		elements.items.add(() -> new ItemCustom());
	}
	public static class ItemCustom extends Item {
		public ItemCustom() {
			super(new Item.Properties().group(ItemGroup.COMBAT).maxStackSize(24).rarity(Rarity.COMMON));
			setRegistryName("low_q_bullet");
		}

		@Override
		public int getItemEnchantability() {
			return 0;
		}

		@Override
		public int getUseDuration(ItemStack itemstack) {
			return 0;
		}

		@Override
		public float getDestroySpeed(ItemStack par1ItemStack, BlockState par2Block) {
			return 1F;
		}

		@Override
		public void addInformation(ItemStack itemstack, World world, List<ITextComponent> list, ITooltipFlag flag) {
			super.addInformation(itemstack, world, list, flag);
			list.add(new StringTextComponent("Ammo for Wood - Stone guns."));
			list.add(new StringTextComponent("Does not eject empty casings for reloading."));
		}
	}
}
